local LuaEngine = luajava.bindClass("com.soco.lua.LuaEngine")
local BindClass = LuaEngine:getLuaStaticClass("BindClass",nil)

local args={...}
-- index 从1开始
local selfModule= args[1]
local textures = {}
local max =10;
local texture
local addLoading = true
local gameLoading
local time

function loadAssetManager()
	print( 'in loadAssetManager()')
end

function initialize()
	print( 'in initialize()')
	
	BindClass.AudioUtil:PlayMusic(selfModule:getLoadMusic(), true);
	selfModule.startTime = BindClass.GameConfig.nowTime;
	selfModule.B_state = selfModule.LOADING;
	if not(selfModule.ui == null) then
		selfModule.ui:init();
	end
	for i= 0, max do
		local sub = "";
		if (i > 0) then
			sub = ""..i;
		end
		local name = "logo".. sub..".png"
		local file = BindClass.Gdx.files:internal(name);
		if not file:exists() then
			break;
		end
		BindClass.ResourceManager:addTexture(name);
		BindClass.ResourceManager:waitLoadFinsh();
		textures[i] = BindClass.ResourceManager:getTexture(name);
	end
	time = 0;
	texture = textures[0];
end

function paint()
	--print( 'in paint()')
	BindClass.DrawUtil:drawRect(0, 0, BindClass.GameConfig.SW, BindClass.GameConfig.SH, BindClass.Color.WHITE, BindClass.ShapeRenderer.ShapeType.Filled);
	local x = (BindClass.GameConfig.SW - texture:getWidth() * BindClass.GameConfig.f_zoomx) / 2;
	local y = (BindClass.GameConfig.SH - texture:getHeight() * BindClass.GameConfig.f_zoomy) / 2;
	BindClass.DrawUtil:draw(texture, x, y, 0, 0, BindClass.GameConfig.f_zoomx, BindClass.GameConfig.f_zoomy, 0, false, false);
end

function run()
	--print( 'in run()')
	time = time + BindClass.Gdx.graphics:getDeltaTime();
	if (addLoading) then
		addLoading = false;
		gameLoading = luajava.newInstance("com.soco.ui.UI_Loading")
		--加载音乐，音效
		if not gameLoading:getLoadMusic() == null then
			BindClass.ResourceManager:addMusic(gameLoading:getLoadMusic());
		end
		--加载LoadingUI
		if not BindClass.ResourceManager:getFile(gameLoading:getLoadUI()) == null then
			local loadingUI = BindClass.Component:load(BindClass.ResourceManager:getFile(gameLoading:getLoadUI()));
			loadingUI.loadAllTextureAtlas(false);
			gameLoading.setUI(loadingUI);
		end
	end
	local index =  (time / 2);
	if (index > (max - 1)) then
		index = max - 1;
	end
	if not (textures[index] == null) then
		texture = textures[index];
	end

	if (BindClass.ResourceManager:update() and textures[index] == null) then

		selfModule.B_state = BindClass.UI_Loading.LOADINGOVER;
		
		print(selfModule.B_state)
	end
end

function release()
	print( 'in release()')
	
	texture:dispose();
	BindClass.SocoMain.gameLoading = gameLoading;
	BindClass.GameManager.loadingMoudule = gameLoading;
	for i= 0, max do
		local sub = "";
		if (i > 0) then
			sub = "" .. i;
		end
		local file = BindClass.Gdx.files:internal("logo" .. sub .. ".png");
		if not file:exists() then
			break;
		end
		BindClass.ResourceManager:unload("logo" .. sub .. ".png");
	end

end

function onKeyDown(keyCode,msg)
	print( 'in onKeyDown()','keyCode=',keyCode,'msg=',msg)
end

function onKeyUp(keyCode,msg)
	print( 'in onKeyUp()','keyCode=',keyCode,'msg=',msg)
end
function onTouchEvent(event)
	print( 'in onTouchEvent()','event=',event)
	if event:getAction()==BindClass.MotionEvent.ACTION_UP then	
		BindClass.GameManager:ChangeModule(nil);			
	end
end
function onUITouchEvent(ui,event)
	print( 'in onUITouchEvent()','ui=',ui,'event=',ui)
end
function touchDown(x, y, pointer, button)
	print( 'in touchDown()','x=',x,'y=',y,'pointer=',pointer,'button=',button)
end
function tap(x, y, count, button)
	print( 'in tap()','x=',x,'y=',y,'count=',count,'button=',button)
end
function longPress(x, y)
	longPress( 'in longPress()','x=',x,'y=',y)
end
function fling(velocityX, velocityY, button)
	print( 'in fling()','velocityX=',velocityX,'velocityY=',velocityY,'button=',button)
end
function pan(x, y, deltaX, deltaY)
	print( 'in pan()','x=',x,'y=',y,'deltaX=',deltaX,'deltaY=',deltaY)
end
function panStop(x, y, pointer, button)
	print( 'in panStop()','x=',x,'y=',y,'deltaX=',pointer,'deltaY=',button)
end
function zoom(initialDistance, distance)
	print( 'in zoom()','initialDistance=',initialDistance,'distance=',distance)
end
function pinch(initialPointer1, initialPointer2, pointer1, pointer2)
	print( 'in pinch()','initialPointer1=',initialPointer1,'initialPointer2=',initialPointer2,'pointer1=',pointer1,'pointer2=',pointer2)
end


